#include <iostream>
#include <math.h>
using namespace std;

long A[10000], B[10000];

int main()	{
	long N, M;
	long sum, C;
	cin>>N>>M;
	for(long i=1; i<=M; i++)
		cin>>B[i];
	cin>>C;
	for(long i=1; i<=N; i++)
		A[i]=i;

	for(long i=0; i<=(N-M); i++)
		for(long j=1; j<=M; j++)
			A[i+B[j]]=A[i+j];

	for(long i=1; i<=N; i++){
		sum+=(long)(A[i]*pow(C, i))%(998244353);
		sum%=998244353;
	}
	cout<<sum;
	
	return 0;
}